#ifndef HTTP_COMM_H
#define HTTP_COMM_H

#define http_comm_name    "HTTP COMM"
#define http_comm_version "0.1"
#define http_comm_date    "Apr 2004"

#define HTTP_GET        0
#define HTTP_POST       1

typedef struct {
  int   header_type;
  int   response_code;
  int   data_length;
  char  content_type[128];
  char  uri[256];
  char  md5[33];
  int   gzip;
} struct_http_header;

typedef struct {
  int       type; // 0 = GET, 1 = POST
  char      host[256];
  int       port;
  char      uri[256];
  int       gzip;
  int       length;
  char*     buf;
  int       buf_size;
} struct_http_req;

typedef struct {
  int       response_code;
  char      response_text[256];
  int       gzip;
  char      file_name[256];
  int       length;
  char*     buf;
  int       buf_size;
  int       sock;
} struct_http_response;

  

void setupHttpServer(int port);
int recvHttpReq(char **msg, struct_http_header **httpHeader);
struct_http_response* createNewHttpResponse(int response_code, char *response_text, int gzip, char *file_name, int sock);
int appendHttpResponse(struct_http_response* http_response, char* data, int len);
int sendHttpResponse(struct_http_response* http_response);

void setupHttpProxy(char* host, int port);
struct_http_req* createNewHttpReq(int type, char* host, int port, char* uri, int gzip);
int appendHttpReq(struct_http_req* http_req, char* data, int len);
char* sendHttpReq(struct_http_req* http_req, int* status);
#endif

